

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css" />
    <link rel='stylesheet' href='https://cdn.jsdelivr.net/npm/sweetalert2@7.12.15/dist/sweetalert2.min.css'>
    <title>Belajar Form Vue Js</title>

    <style>
        .container{
            margin: auto;
            margin-top: 5%;
        }
    </style>
</head>
<body>
    <div id="app">

        <p class="h1" style="text-align: center; margin-top: 5%;">Belajar Form Validation with Vue js</p>
       
        <div class="container">
            <h2>following error validation:</h2>
            <ul>
                <li v-for="error in errors">{{error}}</li>
            </ul>
           

 
        <form v-on:submit.prevent="submitForm()">
            <div class="form-group">
              <label for="name">Name</label>
              <input type="text" name="name" ref="name" class="form-control" id="name" value="name"  placeholder="Enter name" v-model:value="name">
             
            </div>
            <div class="form-group">
              <label for="describtion">Describtion</label>
              <textarea type="text" name="description" ref="description" value="description" rows="3" class="form-control" id="describtion" placeholder="Descriptions" v-model:value="description"  ></textarea>
            </div>
            
            <button type="submit" class="btn btn-primary">Submit</button>
          </form>

          <div style="margin: 20px;">

          <div class="card" style="width: 18rem; margin-right: 10px; display: inline;" v-for="post in posts" >
            <img class="card-img-top" src="./Sandika.jpg" alt="Card image cap">
            <div class="card-body">
              <h5 class="card-title">{{post.title}}</h5>
              <p class="card-text">{{post.description}}</p>
              <button type="button" class="btn btn-primary">Detail</button>
              <button type="button" class="btn btn-danger" @click="onDeleteHandler(post)">Hapus</button>
            </div>
          </div>

          </div>


        </div>




</div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js">
    

    </script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@7.12.15/dist/sweetalert2.all.min.js"></script>
  <script>
   var vm = new Vue({
      el: '#app',
      data: {
          msg:'',
          name:'',
          description:'',
          errors:[],
          posts:[
        
          {
              title:"Sandika",
              description:"sandika galih web developer yang popular"
          },
          {
              title:"Abdul",
              description:"sandika galih web developer yang popular"
          },
          {
              title:"Hamzan",
              description:"sandika galih web developer yang popular"
          },
  
        
        ]
      
      },


      methods: {

      vadlidationForm:function(){
        if (this.name.length<3){
              
            
              this.$refs.name.focus();
              this.errors.push("nama min 3 karakter");
          }
           if (this.description.length <5){
            
              
              this.$refs.description.focus();

              this.errors.push("descripsi min 5 karakter")

          }

      },
        submitForm:async function(){



            let data={
                title:this.name,
                body:this.description
            };

           this.errors=[];

           this.vadlidationForm();

           swal('Anda Yakin Submit ini?');
        //     console.log("data:",data)

            try {

                const res= await axios.post('https://jsonplaceholder.typicode.com/posts',data);
                console.log("response_post:",res);

               

            console.log("masuk pak eko");
            this.name="",
            this.description=""




                
            } catch (error) {
                console.log("error:",error);
                
            }
           
        
        },
        getAllData:async function(){
            try {


                const res= await  axios.get('https://jsonplaceholder.typicode.com/posts');

                this.posts=res.data;
                console.log("res:",res.data);

                // this.posts=res.data
                
            } catch (error) {

                console.log(error)
                
            }


        },
        onDeleteHandler:async function(item){

            console.log("item:",item);

            try {

                const res= await axios.delete(`https://jsonplaceholder.typicode.com/posts/${item.id}`);
                console.log("res:",res);

                
                
            } catch (error) {

                console.log("error:",error);
                
            }

        }

          
      },
      computed:{

        // posts:function(){
        //     return this.getAllData();
        // },
       

      },
      mounted(){
          this.getAllData();

          console.log("post:",this.posts);
      }

      
  })
  </script>

<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" ></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js" ></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"></script>


    
</body>
</html>